#ifndef IZ_WSCLIENT_H
#define IZ_WSCLIENT_H

#include <libwebsockets.h>
#include "../IZ_common.h"

typedef struct {
	struct lws_context* context;
	struct lws* connection;
} IZ_WSClient;

typedef struct {
	u16 port;
	const char* address;
	const char* path;
	const char* protocol;
	void* userdata;
} IZ_WSClientConnectParams;

void IZ_WSClientInitialize(IZ_WSClient*);

IZ_ProcedureResult IZ_WSClientConnect(IZ_WSClient*, IZ_WSClientConnectParams);

IZ_ProcedureResult IZ_WSClientHandle(IZ_WSClient*);

void IZ_WSClientDisconnect(IZ_WSClient*);

#endif
