#ifndef IZ_APP_H
#define IZ_APP_H

#include <signal.h>
#include <stdbool.h>
#include <libwebsockets.h>
#include "IZ_common.h"
#include "log/IZ_log.h"

static bool interrupted;

typedef struct {
	i32 log_level;
	u16 port;
	i32 vhost_options;
	bool extensions_enabled;
} IZ_AppConfig;

typedef struct {
	IZ_AppConfig config;
	struct lws_context* context;
} IZ_App;

static const IZ_AppConfig IZ_APP_DEFAULT_CONFIG = {
	.log_level = LLL_USER | LLL_ERR | LLL_WARN | LLL_NOTICE,
	.port = 42069,
	.vhost_options = 0,
	.extensions_enabled = false,
};

IZ_ProcedureResult IZ_AppRun(IZ_App*, u8, const char**);

#endif
